#include "tlang.h"
tobject_t* __node_scope_execute(node_t* n,scope_t* s)
{
    if(n->data.scope_node.isSub)
    {
        s=scope_begin(s);
    }
    tobject_t* obj_data = tobject_basic(s->rt,tnull);
    tobject_addref(obj_data);
    int i;
    for(i=0;i<n->data.scope_node.count;i++)
    {
        tobject_t* d=n->data.scope_node.items[i]->execute(n->data.scope_node.items[i],s);
        tobject_addref(d); 
        tobject_rmref(obj_data);
        obj_data=d;
    }
    if(n->data.scope_node.isSub)
    {
        s=scope_end(s);
    }
     obj_data->count--; //subtract so we are what we were, can be 0 like usual, should be freed by something
   
    return obj_data;
} 
void __node_scope_free(node_t* node)
{
   node_t** items= node->data.scope_node.items;
   int i;
   for(i=0;i<node->data.scope_node.count;i++)
   {
        node_free(items[i]);
   }
   free(items);
}

node_t* node_scope_create(bool first)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = scopenode;
    n->data.scope_node.count = 0;
    n->data.scope_node.isSub=!first;
    n->data.scope_node.capacity=64;
    n->data.scope_node.items=(node_t**)malloc(sizeof(node_t*) * n->data.scope_node.capacity);
    n->execute = __node_scope_execute;
    n->free = __node_scope_free;
    
    return n;
}
void node_scope_append(node_t* sc,node_t* n)
{
     if(sc->data.scope_node.count + 128 >sc->data.scope_node.capacity)
    {
        sc->data.scope_node.capacity = sc->data.scope_node.count + 128;
        sc->data.scope_node.items=(node_t**)realloc(sc->data.scope_node.items,sc->data.scope_node.capacity * sizeof(node_t*));

    } 
    sc->data.scope_node.items[sc->data.scope_node.count++]=n;
}